using System;
using System.Collections.Generic;
using System.Text;
//QƂǉ܂
using ZundaFramework.Neurons;
using ZundaFramework.Connection;
using ZundaFramework.ODE;
using ZundaFramework.Util;
using HodgkinHuxleySamp.Connection;
using HodgkinHuxleySamp.Neurons;

namespace HodgkinHuxleySamp {
    /// <summary>
    /// Tvt@Cł
    /// </summary>
    class Program {
        static void Main(string[] args) {
            HHNeuronSamp();
            //HHConnectSamp();
        }

        /// <summary>
        /// PȃzWLnNXCfj[̌vZ̃Tvł
        /// Ȃ撣Ă
        /// </summary>
        static void HHNeuronSamp() {
            SimulationLog simlog = new SimulationLog("simlog.txt"); //vZԂȂǂ̃O܂
            Calculator calc = new Calculator(ODEType.RungeKutta4);//̌vZ@w肵܂
            SimulationTime.Delta = 0.005;//vẐݕݒ肵܂
            SimulationTime.EndTime = 500;//IԂݒ肵܂
            SimulationTime.Interval = 50;//o̓t@C̃C^[oݒ肵܂
            ProgressBar pb = new ProgressBar(ProgressBar.Type.Percents);//vOXo[\悤ɂ܂

            HHNeuron n = new HHNeuron();//炵HHNeuron܂D
            
            n.StimulusCurrentFunction = delegate(double t) {//h͂`܂
                if(10 < t && t <= 210) {
                    return 7.0;
                } else if(210 < t && t <= 410) {
                    return 18.0;
                } else {
                    return 0.0;
                }
            };

            MeasureFiringRate fr = new MeasureFiringRate(n);//n̔Ηvfr܂D
            calc.AddNeuron(n);//vZ@nǉ܂

            try {//vZrɒlgꍇɔ
                //o̓t@C̐ݒ܂
                using(DataWriterBinder logs = new DataWriterBinder("data0.txt", "data1.txt", "rate.txt")) {
                    while(SimulationTime.IsSimulation()) {//C[v
                        //Õ݂\bh͉LWriteƂWriteWithTimeȊOɂ낢날̂
                        //Ă݂Ă
                        logs[0].WriteWithTime(n.Potential, n.NaChannel.ActivateNa);//Ȍ
                        logs[1].Write(n);//Ȍ
                        logs[2].WriteAsyncTimeData(fr.GetFiringRate());//Η̏
                        calc.Calc();//vZ1Xebvi߂܂
                    }
                }
            } catch(InvalidOperationException ex) {//l񂾏ꍇ͋I
                Console.Error.Write(ex.ToString());
            }
            pb.Stop();//vOXo[~܂D
            simlog.Finish(calc);//V~[ṼO܂
        }

        /// <summary>
        /// VivXуRp[gg̃Tv
        /// </summary>
        static void HHConnectSamp() {
            SimulationLog simLog = new SimulationLog("log.txt");

            SimulationTime.Delta = 0.005;
            SimulationTime.EndTime = 300;

            HHPre n1 = new HHPre();
            HHPost n2 = new HHPost();
            HHConnect n3 = new HHConnect();
            HHConnect n4 = new HHConnect();

            n1.StimulusCurrentFunction = delegate(double time) {
                if(0.0 < time && time < 200.0) {
                    //return Math.Sin(time * 0.01) * 10 + 10;//h͂͂낢ł
                    return 10;
                } else {
                    return 0.0;
                }
            };
            //n2.StimulusCurrentFunction = delegate(double time) { return 5.0; };

            n2.AddPreNeuron(n1, Syn.NMDA); //n1->n2
            n3.AddPreNeuron(n1, Syn.NMDA); //n1->n3
            n2.AddPreNeuron(n3, Syn.GABA); //n3->n2
            GapConnect.Glue(5, n3, n4);    //n3<=>n4

            //Η̌vZł
            //MeasureFiringRateManager fr = new MeasureFiringRateManager(n1, n2, n3);

            Calculator calc = new Calculator(ODEType.SimpleEuler, n1, n2, n3, n4);

            try {
                using(DataWriterBinder logs = new DataWriterBinder("data.txt", "data1.txt")) {
                    logs.WriteInterval = 50;
                    while(SimulationTime.IsSimulation()) {
                        logs[0].WriteWithTime(n1.Potential, n2.Potential, n3.Potential, n4.Potential);
                        //logs[1].WriteAsyncTimeData(fr.GetFiringRates());//Η̏o
                        //logs[1].Write(t.Time, n1.GetSynapticCurrents(), n2.GetSynapticCurrents());//VivX̌ʂ̓do͂ł
                        calc.Calc();
                    }
                }
            } catch(InvalidOperationException ex) {
                Console.Error.Write(ex.ToString());
            }

            simLog.Finish(calc);
        }
    }
}
